// Attention !
// Les SoQtExaminerViewer et autres possdent leur propre routine
// d'interception des vnements. Il faut donc les configurer
// autrement.
// Voir exemple 03_event

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/SoQtRenderArea.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/events/SoKeyboardEvent.h>

// Routine d'interception des vnements claviers.
// Doit respecter une signature du type void fnct(void*,SoEventCallback*)
void keyboard(void* userData, SoEventCallback* evt)
{
     SoMaterial* mat=(SoMaterial*)userData;
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), R))
     {
	  mat->diffuseColor.setValue(1.0,0.0,0.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), V))
     {
	  mat->diffuseColor.setValue(0.0,1.0,0.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), B))
     {
	  mat->diffuseColor.setValue(0.0,0.0,1.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), Q))
     {
	  SoQt::exitMainLoop();
	  return;
     }
}



int main(int argc, char** argv)
{
     QWidget* myWidget= SoQt::init(argc,argv,argv[0]);

// Il s'agit de la cration d'un cne rouge.
     SoSeparator* root = new SoSeparator;
     root->ref(); // Augmenter le compteur de rfrences

     // Ajout d'une camra
     SoPerspectiveCamera* camera=new SoPerspectiveCamera;
     root->addChild(camera);
     // Ajout d'une lumire
     root->addChild(new SoDirectionalLight);
     // Ajout d'une couleur
     SoMaterial*  mat = new SoMaterial ;
     mat->diffuseColor.setValue(1.0, 0.0, 0.0);
     root->addChild(mat);
     // Ajout d'un cone
     root->addChild(new SoCone);
     // Ajout d'un noeud de rception des vnements
     SoEventCallback* eventCB = new SoEventCallback;
     eventCB->addEventCallback( SoKeyboardEvent::getClassTypeId(), 
				keyboard, mat);
     root->addChild(eventCB);

     
     SoQtRenderArea *myRenderArea = new SoQtRenderArea(myWidget);

     // Pour visionner la scne
     camera->viewAll(root,myRenderArea->getViewportRegion());
     myRenderArea->setSceneGraph(root);     
     myRenderArea->show();

     SoQt::show(myWidget);
     SoQt::mainLoop();

     delete myRenderArea;
     return 0;
}
