// Attention !
// Les SoQtExaminerViewer ne grent la routine d'vnement 
// que lorsque plac dans le bon mode.
// fonction setViewing(false);


#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/events/SoKeyboardEvent.h>


// Routine d'interception des vnements claviers.
// Doit respecter une signature du type void fnct(void*,SoEventCallback*)
void keyboard(void* userData, SoEventCallback* evt)
{
     SoMaterial* mat=(SoMaterial*)userData;
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), R))
     {
	  mat->diffuseColor.setValue(1.0,0.0,0.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), V))
     {
	  mat->diffuseColor.setValue(0.0,1.0,0.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), B))
     {
	  mat->diffuseColor.setValue(0.0,0.0,1.0);
	  evt->setHandled();
	  return;
     }
     if ( SO_KEY_PRESS_EVENT(evt->getEvent(), Q))
     {
	  SoQt::exitMainLoop();
	  return;
     }
}



int main(int argc, char** argv)
{
     QWidget* myWidget= SoQt::init(argc,argv,argv[0]);

// Il s'agit de la cration d'un cne rouge.
     SoSeparator* root = new SoSeparator;
     root->ref(); // Augmenter le compteur de rfrences
     SoMaterial*  mat = new SoMaterial ;
     mat->diffuseColor.setValue(1.0, 0.0, 0.0);

     SoEventCallback* eventCB = new SoEventCallback;
     eventCB->addEventCallback( SoKeyboardEvent::getClassTypeId(), 
     			keyboard, mat);
     root->addChild(eventCB);

     // Ajout d'une couleur
     root->addChild(mat);
     // Ajout d'un cone
     root->addChild(new SoCone);
     
     SoQtExaminerViewer *myRenderArea = new SoQtExaminerViewer(myWidget);
     myRenderArea->setSceneGraph(root);
     // important si l'on veut capturer les vnements utilisateur
     myRenderArea->setViewing(false);
     myRenderArea->show();

     SoQt::show(myWidget);
     SoQt::mainLoop();

     delete myRenderArea;
     return 0;
}
