#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoEventCallback.h>
#include <Inventor/events/SoMouseButtonEvent.h>
#include <Inventor/actions/SoRayPickAction.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoAnnotation.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoSelection.h>
#include <Inventor/nodes/SoText2.h>



#include <iostream>

SbString help[] = { "toto", "tata", "tutu"};


void selection(void * userData,SoPath* selectionPath)
{   
    for (int i=0; i < selectionPath->getLength() ; i++)
    {
        SoNode* node = selectionPath->getNodeFromTail(i);
        if (node->isOfType(SoSeparator::getClassTypeId()))
        {
            SoSeparator* sep = (SoSeparator*)node;
            SoMaterial* mat = new SoMaterial; 
            mat->diffuseColor.setValue(1.0,0.0,0.0);
            sep->insertChild(mat,0);
            return ;
        }
    }
}


void deselection(void*, SoPath* selectionPath)
{
    for (int i=0; i < selectionPath->getLength(); i++)
    {
        SoNode* node= selectionPath->getNodeFromTail(i);
        if (node->isOfType(SoSeparator::getClassTypeId()))
        {
            SoSeparator* sep= (SoSeparator*)node;
            if (sep->getChild(0)->isOfType(SoMaterial::getClassTypeId()))
            {
                sep->removeChild(0);
                return;
            }
        }
    }
}


int main(int argc, char** argv)
{
     QWidget* myWidget= SoQt::init(argc,argv,argv[0]);

     // Initialisation de la scne
     // + cration d'un noeud de selection
     SoSelection* sel = new SoSelection;
     sel->policy = SoSelection::SHIFT;
     sel->ref(); //Augmenter le compteur  de rfrences
     sel->addSelectionCallback(selection);
     sel->addDeselectionCallback(deselection);

     SoSeparator* root = new SoSeparator;

     SoSeparator* rootbis = new SoSeparator;
     rootbis->addChild(new SoPerspectiveCamera);
     root->addChild(rootbis);

     root->ref(); // Augmenter le compteur de rfrences
     rootbis->addChild(sel);


     // Couleur gnrale
     SoMaterial*  mat = new SoMaterial ;
     mat->diffuseColor.setValue(0.0, 1.0, 1.0);

     // Ajout d'une couleur
     sel->addChild(mat);

     SoRotationXYZ* r0 = new SoRotationXYZ;
     r0->axis.setValue("X");
     r0->angle.setValue(0.30);
     sel->addChild(r0);
     SoRotationXYZ* r1 = new SoRotationXYZ;
     r1->axis.setValue("Z");
     r1->angle.setValue(0.15);
     sel->addChild(r1);


     SoSeparator* sep0 = new SoSeparator;
     SoTranslation* tr0 = new SoTranslation;
     tr0->translation.setValue(2.0, 2.0, 0.0);
     sep0->addChild(tr0);
     sep0->addChild(new SoCube);
     sel->addChild(sep0);

     SoSeparator* sep1 = new SoSeparator;
     SoTranslation* tr1 = new SoTranslation;
     tr1->translation.setValue(2.0, -2.0, 0.0);
     sep1->addChild(tr1);
     sep1->addChild(new SoCube);
     sel->addChild(sep1);

     SoSeparator* sep2 = new SoSeparator;
     SoTranslation* tr2 = new SoTranslation;
     tr2->translation.setValue(-2.0, -2.0, 0.0);
     sep2->addChild(tr2);
     sep2->addChild(new SoCube);
     sel->addChild(sep2);

     SoSeparator* sep3 = new SoSeparator;
     SoTranslation* tr3 = new SoTranslation;
     tr3->translation.setValue(-2.0, 2.0, 0.0);
     sep3->addChild(tr3);
     sep3->addChild(new SoCube);
     sel->addChild(sep3);

     SoOrthographicCamera* cam = new SoOrthographicCamera;
     cam->viewportMapping = SoCamera::LEAVE_ALONE ;
     root->addChild(cam);

     SoAnnotation* an = new SoAnnotation;
     root->addChild(an);
     SoText2* txt= new SoText2();
     txt->string.setValues(0,sizeof(help)/sizeof(help[0]),help);
     SoTranslation* trText = new SoTranslation;
     trText->translation.setValue(-0.9,0.9,0.0);
     an->addChild(trText);
     an->addChild(txt);
     


     
     SoQtExaminerViewer *myRenderArea = new SoQtExaminerViewer(myWidget);
     myRenderArea->setSceneGraph(root);
     myRenderArea->setViewing(false);
     myRenderArea->show();
     myRenderArea->viewAll();

     SoQt::show(myWidget);
     SoQt::mainLoop();

     delete myRenderArea;
     return 0;
}
