#include "conebutton.h"

#include <Inventor/nodes/SoCone.h>

// Constructeur
ConeButton::ConeButton() : QObject()
{
     float green = 0.0;

     // Cration du graphe de scne
     separator = new SoSeparator;
     separator->ref();

     mat = new SoMaterial ;
     mat->diffuseColor.setValue(1.0, green, 0.0);
     separator->addChild(mat);
     separator->addChild(new SoCone);
}

// Destructeur
ConeButton::~ConeButton()
{
     // Le graphe n'est plus ncessaire : drfrencement
     separator->unref();
}

// implmentation du slot
void ConeButton::changeMaterial()
{
     // Changement de la composante verte.
     // Si green = 1.0, le cone est jaune, rouge sinon
     green = 1.0 - green;
     mat->diffuseColor.setValue(1.0, green, 0.0);
}
