#include "conebutton.h"

#include <Inventor/Qt/SoQt.h>
#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>

#include <QApplication>
#include <QPushButton>
#include <QVBoxLayout>
#include <QTimer>

int main(int argc, char** argv)
{
     // Cration d'une application Qt
     QApplication app(argc,argv);
     // VBox : layout alignant verticalement les widgets enfants
     QWidget* widget= new QWidget();
     QVBoxLayout* vbox = new QVBoxLayout();

     // Initialiser SoQt
     SoQt::init(widget);
     // Initialiser notre graphe de scne 
     ConeButton cb;

     // Crer une zone de rendu
     SoQtExaminerViewer *myRenderArea = new SoQtExaminerViewer(widget);
     // Crer un bouton "Click me"
     QPushButton* button=new QPushButton("Click me");

     vbox->layout()->addWidget(myRenderArea->getWidget());
     vbox->layout()->addWidget(button);
     // Connecter le bouton  notre graphe de scne
     // un clic sur le bouton emet le signal clicked(),
     // Celui-ci est connect pour changer la couleur
     // Du cne dans le graphe de scne.
     QObject::connect(button,SIGNAL(clicked()), &cb, SLOT(changeMaterial()));
     // Rcuprer le graphe de scne et l'afficher
     myRenderArea->setSceneGraph(cb.getSceneGraph());

     // Redimensionnement du Widget
     widget->setLayout(vbox);
     widget->resize(640,480);
     widget->show();
    
     // Lancement de la boucle principale
     SoQt::mainLoop();

     // L'effacement de vbox, pre de tous les widgets,
     // efface aussi ses enfants.
     delete widget;
     return 0;
}
