#include "ivloader.h"

#include <Inventor/Qt/SoQt.h>
#include <QFileDialog>
#include <QDir>
#include <QMessageBox>


IVLoader::IVLoader(QWidget* parent) : QWidget(parent)
{
     SoQt::init(parent);
     viewer = new SoQtExaminerViewer(this);
     separator = new SoSeparator;
     separator->ref();
     viewer->setSceneGraph(separator);
     viewer->show();
}

IVLoader::~IVLoader()
{
     delete viewer;
}


void IVLoader::openFile(QString s)
{
     // Lecture du graphe de scne
     SoInput sceneInput;
     if ( !sceneInput.openFile(qPrintable(s)))
     { 
	  QMessageBox::information(this, 
				   "Erreur de lecture", 
				   "Le fichier slectionn n'a pu tre ouvert.");
	  return;
     }
     separator = SoDB::readAll(&sceneInput);
     if ( separator == NULL)
     { 
	  QMessageBox::information(this, 
				   "Erreur de lecture", 
				   "Le fichier slectionn n'a pu tre dcod.");
	  return ;
     }
     sceneInput.closeFile();

     // Association du graphe de scne au viewer
     viewer->setSceneGraph(separator);
     viewer->render();
}

void IVLoader::openFileDialog()
{
     // ouverture d'une bote de dialogue
     QString s = QFileDialog::getOpenFileName( this, 
             "open file dialog", 
	  QDir::currentPath(),
	  "Inventor files (*.iv)");
     
     // Si annulation alors arrter
     if (s.isEmpty())
	  return ;

     openFile(s);
}

